#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#define npct 5
#define npctm1 4
#define npar 3
#define nparm1 2
/*
 *	Metoda gradientului pentru rafinarea 
 *  parametrilor unui model neliniar n 
 *	metoda celor mai mici patrate
 */

 /*        declaratii de variabile             */
     double t[npct]={0,10,30,100,300};
     double d[npct]={1.2,1.57,1.88,2.02,1.92},dc[npct];
     double w[npar],x[npar]={2.0,0.5,0.3},g[npar];
     double eps=1,alfa=0.25,ff,f0,gnorm;
     int    i=0,itn=0;
/*--------------------------------------------*/

double F(double w[npar])// Functionala c.m.m.p. 
{
	int i;
  double b=0,a;
	for (i = 0 ; i <=npctm1 ; a = w[ 0 ] * ( 1 - w [ 1 ] * exp ( -w [ 2 ] * t [ i ] )),
			           		 a = d [ i ] - a ,
			           		 b = b + a * a,                         
			           		 i++);

	return ( b ) ;
   }
/*--------------------------------------------*/

double der(int k , double x[npar] , double f0 )

/* Derivata partiala a functionalei c.m.m.p.*\ 
\*   dupa componenta k a vectorului x[]     */
{
	double temp,tempx;
  int i;
  temp = (x[k] > 0.1 ) ? x[k]*eps : 0.1 * eps ;
  tempx = x[k] ;
  x[k] += temp ;
  temp = (F(x)-f0)/temp;
  x[k] = tempx;
  return ( temp );
}
/*--------------------------------------------*/
  void main(void)
 {
 while (1 + eps != 1 ) eps /= 2 ; // Lungimea mantisei masinii 
 eps = sqrt ( 2*eps ) ;       // Constanta folosita in derivarea numerica 
/// clrscr();
 ff=F(x);
 while ((gnorm>1e-8) || (alfa>1e-1))
 {
 	itn = itn + 1 ;
  gnorm = 0 ;
  f0=F(x);
  for ( i=0 ; i<=nparm1 ; g[i] = der (i,x,f0),
		      								gnorm=gnorm+g[i]*g[i],
		      								w[i]=x[i]-alfa*g[i],i++);
  f0=F(w);
  for (i=0 ; i <= nparm1 ;printf ("\n%10.6lf %10.6lf", x[i],g[i]),
                          i++ );
  printf ("    ff= %lf \n", ff ) ;
  // actualizare 
  if (f0 <= ff)
	  for (ff=f0 , i=0 ; i <= nparm1; x[i] = w[i],i++);
  else alfa=alfa/2;      // divergenta -> micsorarea pasului
}
    /*/ Sfarsitul procesului iterativ /*/

printf ("===============================\n");
printf (" PARAMETRII FINALI AI MODELULUI\n");
printf ("-------------------------------\n");
printf ("I      x[I]       g[I]\n");
printf ("--------------------------------");
x[0] = x[0]*10;
for (i=0 ; i <= nparm1 ;
       printf ("\n%d %10.6lf %10.6lf\n",i+1 ,x[i],g[i]),i++ );
printf ("=============================== \n");
putchar ('\n');
printf ("NORMA GRADIENTULUI= %lf ",sqrt (gnorm));
putchar ('\n');
printf ("REZIDUUL LA ITERATIA FINALA= %lf ",f0*100);
putchar ('\n');
printf ("NUMARUL DE ITERATII= %d\n\a",itn);
getch ();
}
